Serialization in EJ2 JavaScript Diagram

7 Aug 202622 minutes to read

Serialization is the process of converting the state of the diagram into a format that can be saved and later restored. This ensures that the diagram’s current state, including its nodes, connectors, and configurations, can be persisted across sessions.

Serialization involves saving the diagram’s state as a JSON string, which can then be stored in a database, file, or other storage medium. When needed, the serialized string can be deserialized to recreate the diagram in its previous state.

Save

The diagram method saveDiagram, helps to serialize the diagram as a string. This method captures the entire diagram’s configuration and content, converting it into a string representation.

The following code illustrates how to save the diagram:

//returns serialized string of the Diagram
var savedData = diagram.saveDiagram();

This JSON string can be stored in local storage for future use. The following code illustrates how to save the serialized string into local storage and how to retrieve it:

// Store the serialized string in local storage
localStorage.setItem('fileName', savedData);

// Retrieve the saved string from local storage
savedData = localStorage.getItem('fileName');

The diagram can also be saved as raster or vector image files. For more information about saving the diagram as images, refer to the Print and Export section.

Load

The diagram can be loaded from serialized string data using the loadDiagram method. The saved string should be passed as the parameter of the loadDiagram method. The following code illustrates how to load the diagram from serialized string data:

/*
 * Loads the diagram from saved JSON data.
 * parameter 1 - The string representing the diagram model JSON to be loaded.
 * parameter 2 - Whether it is ej1 data or not (optional)
 */
diagram.loadDiagram(savedData);

Before loading a new diagram, existing diagram is cleared.

Prevent Default Values

The preventDefaults property of serializationSettings is used to simplify the saved JSON object by excluding default properties that are inherent to the diagram. This helps reduce the size of the serialized data and improves efficiency when saving and loading diagrams.

By enabling preventDefaults, only properties that you set in diagram are included in the serialized JSON object. This optimization is useful for scenarios where minimizing data size is crucial, such as in applications with large diagrams or when optimizing network transfers.

The following code illustrates how to enable the preventDefaults property to simplify the JSON object:

var diagram = new ej.diagrams.Diagram({
 serializationSettings: { preventDefaults: true },
});

Detect unsaved changes

The isModified property indicates whether the diagram has unsaved changes. It becomes true when the diagram is changed, such as when nodes, connectors, or diagram properties are updated, or when undo and redo actions are performed.

For example, this property can be used to show a save indicator or display a warning message before closing or navigating away from a diagram with unsaved changes.

// Check whether the diagram has unsaved changes.
if (diagram.isModified) {
    const confirmed = confirm('There are unsaved changes. Discard them?');

    if (!confirmed) {
        return;
    }
}

Transient interactions such as zooming, panning, or selecting elements do not affect the isModified state.

Save and load diagram using uploader control

The JSON files can be uploaded using the uploader component, where they are parsed to extract the JSON data they contain. To achieve this, configure the uploader component with the saveUrl property to receive uploaded files and store them on the server. Similarly, use the removeUrl property to handle file removal operations on the server.

When a JSON file is uploaded, it undergoes parsing to extract its JSON data. This data is then loaded into the diagram using the loadDiagram method.

// initialize Uploader component
var uploadObject = new ej.inputs.Uploader({
    asyncSettings: {
      saveUrl:
        'https://services.syncfusion.com/js/production/api/FileUploader/Save',
      removeUrl:
        'https://services.syncfusion.com/js/production/api/FileUploader/Remove',
    },
    success: onUploadSuccess,
  });
  
  // render initialized Uploader
  uploadObject.appendTo('#fileupload');
  function onUploadSuccess(args) {
    var file1 = args.file;
    var file = file1.rawFile;
    var reader = new FileReader();
    reader.readAsText(file);
    reader.onloadend = loadDiagram;
  }
  
  var nodes = [
    {
      id: 'Start',
      width: 140,
      height: 50,
      offsetX: 300,
      offsetY: 50,
      annotations: [
        {
          id: 'label1',
          content: 'Start',
        },
      ],
      shape: {
        type: 'Flow',
        shape: 'Terminator',
      },
    },
  ];
  
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '600px',
      nodes: nodes,
    },
    '#element'
  );
  //Load the diagraming object.
  function loadDiagram(event) {
    diagram.loadDiagram(event.target.result);
  }
  
  document.getElementById('btnSave').onclick = function () {
    download(diagram.saveDiagram());
  };
  //save the diagram object in json data.
  function download(data) {
    if (window.navigator.msSaveBlob) {
      var blob = new Blob([data], { type: 'data:text/json;charset=utf-8,' });
      window.navigator.msSaveOrOpenBlob(blob, 'Diagram.json');
    } else {
      var dataStr = 'data:text/json;charset=utf-8,' + encodeURIComponent(data);
      var a = document.createElement('a');
      a.href = dataStr;
      a.download = 'Diagram.json';
      document.body.appendChild(a);
      a.click();
      a.remove();
    }
  }
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 Load Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 Diagram Component">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
        <div id="container">
          <label>Browse to load</label>
          <input type="file" id="fileupload" name="UploadFiles" />
          <button id="btnSave">Save Diagram</button>
            <div id="element"></div>
        </div>
    

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Importing and Exporting Diagrams using Mermaid Syntax

The Diagram supports saving diagrams in Mermaid syntax format. Mermaid is a Markdown-inspired syntax that automatically generates diagrams. With this functionality, you can easily create mind maps, flowcharts, and UML sequence diagrams from Mermaid syntax data, simplifying the visualization of complex ideas and processes without manual drawing. Additionally, you can export your mind maps, flowcharts, and UML sequence diagrams to Mermaid syntax, allowing for easy sharing, editing, and use across different platforms.

Save diagram as Mermaid syntax

The saveDiagramAsMermaid method serializes the diagram into a Mermaid-compatible string format. This method is specifically designed for diagrams that utilize Flowchart and Mind map layouts. The following code illustrates how to save the diagram in Mermaid string format.

//returns the serialized Mermaid string of the Diagram
let data = diagram.saveDiagramAsMermaid();

Load diagram from Mermaid syntax

You can load a diagram from the serialized Mermaid syntax data using the loadDiagramFromMermaid method. The following code illustrates how to load a diagram from a Mermaid string data.

Load flowchart layout

The following example shows how to load flowchart diagram from mermaid syntax.

ej.diagrams.Diagram.Inject(ej.diagrams.Flowchart);
var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '600px',
    layout: { type: 'Flowchart' },
    getNodeDefaults: function (obj) {
      obj.width = 120;
      obj.height = 50;
      if (obj.shape.shape === 'Decision') {
        obj.height = 80;
      }
      obj.annotations[0].style.bold = true;
      return obj;
    }, getConnectorDefaults: function (connector) {
      connector.type = 'Orthogonal';
      connector.style.strokeColor = '#6CA0DC';
      connector.targetDecorator.style = { fill: '#6CA0DC', strokeColor: '#6CA0DC' };
      return connector;
    }
  });
  diagram.appendTo('#element');

let mermaidFlowchartData = `flowchart TD
    A[Start] --> B(Process)
    B -.- C{Decision}
    C --Yes--> D[Plan 1]
    C ==>|No| E[Plan 2]
    style A fill:#90EE90,stroke:#333,stroke-width:2px;
    style B fill:#4682B4,stroke:#333,stroke-width:2px;
    style C fill:#FFD700,stroke:#333,stroke-width:2px;
    style D fill:#FF6347,stroke:#333,stroke-width:2px;
    style E fill:#FF6347,stroke:#333,stroke-width:2px;`;

(document.getElementById('loadMermaidFlowchart')).onclick = function () {
  // load the mermaid flowchart data to diagram
  //parameter: mermaidFlowchartData - mermaid format string data for flowchart
  diagram.loadDiagramFromMermaid(mermaidFlowchartData);
};
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 Load Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 Diagram Component">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
        <div id="container">
          <button id="loadMermaidFlowchart">Load</button>
            <div id="element"></div>
        </div>
    

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Load mindmap layout

The following example shows how to load mind map diagram from mermaid syntax.

ej.diagrams.Diagram.Inject(ej.diagrams.MindMap);
var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '600px',
    layout:{
      type:'MindMap',
      verticalSpacing: 50,
      horizontalSpacing: 50,
      orientation: 'Horizontal',
  },
    getNodeDefaults: function (obj) {
      obj.width = 120;
      obj.height = 50;
      obj.annotations[0].style.bold = true;
      return obj;
    }, getConnectorDefaults: function (connector) {
      connector.type = 'Orthogonal';
      connector.style.strokeColor = '#6CA0DC';
      connector.targetDecorator.shape = 'None';
      return connector;
    }
  });
diagram.appendTo('#element');

let mermaidMindmapData = `mindmap
                            root((mindmap))
                              Origins
                                Popularisation
                              Research
                                On effectivness<br/>and features
                                On Automatic creation
                              Tools
                                Pen and paper
                                Mermaid`;

(document.getElementById('loadMermaidMindmap')).onclick = function () {
  // load the mermaid mindmap data to diagram
  //parameter: mermaidMindmapData - mermaid format string data for mindmap
  diagram.loadDiagramFromMermaid(mermaidMindmapData);
};
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 Load Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 Diagram Component">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
        <div id="container">
          <button id="loadMermaidMindmap">Load</button>
            <div id="element"></div>
        </div>
    

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Load UML Sequence diagram

The following example shows how to load UML Sequence diagram from mermaid syntax.

var diagram = new ej.diagrams.Diagram({
    width: '100%',
    height: '600px',
  });
diagram.appendTo('#element');

var mermaidData = `
 sequenceDiagram
    participant User
    participant Controller
    participant Service
    participant Database

    User->>Controller: sendRequest()
    activate Controller

    Controller->>Service: processRequest()
    activate Service

    Service->>Database: queryData()
    activate Database
    Database-->>Service: returnData()
    deactivate Database

    Service-->>Controller: returnResponse()
    deactivate Service

    Controller-->>User: sendResponse()
    deactivate Controller`;

(document.getElementById('loadMermaidSeqDiagram')).onclick = function () {
  // load the mermaid sequence diagram data to diagram
  //parameter: mermaidData - mermaid format string data for UML Sequence Diagram
  diagram.loadDiagramFromMermaid(mermaidData);
};
<!DOCTYPE html>
<html lang="en">

<head>
  <title>Essential JS 2 Load Diagram</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="description" content="Essential JS 2 Diagram Component">
  <meta name="author" content="Syncfusion">
  <link href="index.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/tailwind3.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">


  <script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

  <div id="container">
    <button id="loadMermaidSeqDiagram">Load Mermaid</button>
    <div id="element"></div>
  </div>


  <script>
    var ele = document.getElementById('container');
    if (ele) {
      ele.style.visibility = "visible";
    }   
  </script>
  <script src="index.js" type="text/javascript"></script>
</body>

</html>

Mermaid syntax-based serialization and deserialization is supported only for Flowchart layout, Mind map layout, and UML Sequence Diagram. Ensure that your Mermaid data aligns with one of these supported layouts to enable successful diagram loading.

Serialization in Angular Diagram

6 Aug 202618 minutes to read

Serialization is the process of converting the diagram’s current state into a storage format that can be saved and later restored. This feature ensures that all diagram elements, including nodes, connectors, and their configurations, persist across application sessions.

The serialization process converts the diagram into a JSON string format, which can be stored in databases, files, or other storage systems. When needed, this serialized data can be deserialized to recreate the diagram exactly as it was previously configured.

Use serialization when you need to:

  • Save user-created diagrams for future editing
  • Implement undo/redo functionality
  • Create diagram templates
  • Transfer diagrams between different sessions or users

To save and load the diagram in Angular, refer to the below video link.

Saving Diagrams

Basic Save Operation

The saveDiagram method serializes the entire diagram configuration into a JSON string. This method captures all diagram elements, their properties, and the current state.

//returns serialized string of the Diagram
saveData = this.diagram.saveDiagram();

The serialized JSON string can be stored in various storage systems. The following example demonstrates local storage implementation:

//Saves the string in to local storage
localStorage.setItem('fileName', saveData);

// Retrieve the saved string from local storage
saveData = localStorage.getItem('fileName');

Alternative Save Formats

The diagram can also be saved as raster or vector image files. For more information about saving the diagram as images, refer to the Print and Export sections.

Loading Diagrams

Basic Load Operation

The loadDiagram method recreates the diagram from serialized JSON data. This method accepts the previously saved JSON string as a parameter.

export class AppComponent {
  @ViewChild('diagram', { static: true }) diagram: DiagramComponent;
  
  loadDiagram(): void {
    const savedData: string = localStorage.getItem('diagramData');
    
    if (savedData) {
      /*
       * Loads the diagram from saved JSON data.
       * parameter 1 - The string representing the diagram model JSON to be loaded.
       * parameter 2 - Whether it is ej1 data or not (optional)
       */
      this.diagram.loadDiagram(savedData);
      console.log('Diagram loaded successfully');
    } else {
      console.warn('No saved diagram data found');
    }
  }
}

Before loading a new diagram, the existing diagram content is automatically cleared.

Handling Load Completion

The loaded event triggers when all diagram elements finish loading through the loadDiagram method. Use this event to perform post-load customizations or validations.

<ejs-diagram #diagram id="diagram" width="100%" height="700px" (loaded)="loaded()" >
</ejs-diagram>
export class AppComponent {
  public loaded(args:ILoadedEventArgs): void {
      //You can use this event to customize diagram elements during the loading process
  }
}

The loaded event provides the following arguments:

name

  • Type: String
  • Description: Returns the event name

diagram

  • Type: Diagram
  • Description: Returns the complete diagram model with all properties

Optimizing Serialized Data

Preventing Default Values

The preventDefaults property within serializationSettings reduces the size of serialized data by excluding default properties. This optimization improves performance when handling large diagrams or frequent save operations.

When enabled, only explicitly set properties are included in the JSON output, significantly reducing file size and improving load times.

<ejs-diagram #diagram id="diagram" width="100%" height="700px" (serializationSettings)="serializationSettings" >
</ejs-diagram>
export class AppComponent {
  public serializationSettings: SerializationSettingsModel = {};
  
  ngOnInit() {
    this.serializationSettings = { preventDefaults: true };
  }
}

Detect Unsaved Changes

The isModified property indicates whether the diagram has unsaved changes. It becomes true when the diagram is changed, such as when nodes, connectors, or diagram properties are updated, or when undo and redo actions are performed.

This property can be used to show save indicators or to display a warning before unsaved changes are discarded.

// Check whether the diagram has unsaved changes.
if (diagram.isModified) {
    const confirmed = confirm('You have unsaved changes. Discard them?');
    if (!confirmed) return;
}
navigateTo('/home');

File-Based Save and Load Operations

Using Uploader Component

JSON files can be uploaded and processed using the uploader component. Configure the uploader with appropriate server endpoints to handle file operations, then parse the uploaded JSON data to load diagrams.

The uploader requires:

  • saveUrl property for receiving and storing uploaded files
  • removeUrl property for handling file deletion operations
  • File parsing logic to extract JSON data from uploaded files
import { ViewChild, Component, ViewEncapsulation  } from '@angular/core';
import { DiagramComponent, DiagramModule } from '@syncfusion/ej2-angular-diagrams';
import { Uploader, FileInfo } from '@syncfusion/ej2-inputs';
import { NodeModel } from '@syncfusion/ej2-diagrams';

@Component({
  imports: [DiagramModule],

  providers: [],
  standalone: true,
  selector: 'app-container',
  template: ` <div> <input id="fileupload" type="file" />
  <button (click)="onSaveClick()">Save Diagram</button> </div>
  <ejs-diagram #diagram id="diagram" width="100%" height="600px" [nodes]="nodes" > </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
  @ViewChild("diagram")
  public diagram!: DiagramComponent;
  public uploadObject: Uploader;
  public nodes: NodeModel[] = [];
  constructor() {
    this.uploadObject = new Uploader({
      asyncSettings: {
        saveUrl:
          'https://services.syncfusion.com/js/production/api/FileUploader/Save',
        removeUrl:
          'https://services.syncfusion.com/js/production/api/FileUploader/Remove',
      },
      success: this.onUploadSuccess.bind(this),
    });
  }
  ngOnInit() {
    // Initialize nodes
    this.nodes = [
    {
      id: 'Start',
      width: 140,
      height: 50,
      offsetX: 300,
      offsetY: 50,
      annotations: [{ id: 'label1', content: 'Start' }],
      shape: { type: 'Flow', shape: 'Terminator' },
    },
  ];
}

  ngAfterViewInit() {
    this.uploadObject.appendTo('#fileupload');
  }

  onUploadSuccess(args: { file: FileInfo }) {
    const file: any = args.file.rawFile;
    const reader = new FileReader();
    reader.readAsText(file);
    reader.onloadend = this.loadDiagram.bind(this);
  }

  loadDiagram(event: ProgressEvent<FileReader>) {
    const jsonString = event.target?.result as string;
    this.diagram.loadDiagram(jsonString);
  }

  download(data: string): void {
    if ((window.navigator as any).msSaveBlob) {
      const blob: any = new Blob([data], {
        type: 'data:text/json;charset=utf-8,',
      });
      (window.navigator as any).msSaveBlob(blob, 'Diagram.json');
    } else {
      const dataStr: string =
        'data:text/json;charset=utf-8,' + encodeURIComponent(data);
      const a: HTMLAnchorElement = document.createElement('a');
      a.href = dataStr;
      a.download = 'Diagram.json';
      document.body.appendChild(a);
      a.click();
      a.remove();
    }
  }

  onSaveClick() {
    this.download(this.diagram.saveDiagram());
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Mermaid Syntax Integration

Overview

The Diagram component supports importing and exporting diagrams using Mermaid syntax. Mermaid is a markdown-inspired syntax for creating diagrams programmatically, enabling easy diagram creation and sharing across different platforms.

This functionality supports:

  • Mind maps
  • Flowcharts
  • UML sequence diagrams

Saving Diagrams as Mermaid Syntax

The saveDiagramAsMermaid method converts compatible diagrams into Mermaid syntax format. This method works specifically with Flowchart and Mind map layouts.

//returns the serialized Mermaid string of the Diagram
data = this.diagram.saveDiagramAsMermaid();

Loading Diagrams from Mermaid Syntax

The loadDiagramFromMermaid method creates diagrams from Mermaid syntax data, automatically generating the appropriate layout and styling.

Loading Flowchart Layout

The following example demonstrates loading a flowchart diagram from Mermaid syntax:

import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { DiagramComponent, DiagramModule } from '@syncfusion/ej2-angular-diagrams';
import { Diagram, NodeModel, ConnectorModel, FlowShapeModel, FlowchartLayout } from '@syncfusion/ej2-diagrams';

Diagram.Inject(FlowchartLayout);

@Component({
  imports: [
    DiagramModule
  ],

  providers: [],
  standalone: true,
  selector: "app-container",
  template: `
  <button (click)="loadMermaidFlowchart()">Load</button>
  <ejs-diagram #diagram id="diagram" width="100%" height="600px" [getNodeDefaults]="getNodeDefaults"
  [getConnectorDefaults]="getConnectorDefaults" [layout]="layout"> </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  @ViewChild("diagram")
  public diagram!: DiagramComponent;

  public getNodeDefaults(node: NodeModel): NodeModel {
    node.width = 120;
    node.height = 50;
    if ((node.shape as FlowShapeModel).shape === 'Decision') {
      node.height = 80;
    }

    return node;
  }

  public getConnectorDefaults(connector: ConnectorModel): ConnectorModel {
    connector.type = 'Orthogonal';
    return connector;
  }

  public layout = { type: 'Flowchart' }

  public loadMermaidFlowchart() {
    const mermaidFlowchartData = `flowchart TD
        A[Start] --> B(Process)
        B -.- C{Decision}
        C --Yes--> D[Plan 1]
        C ==>|No| E[Plan 2]
        style A fill:#90EE90,stroke:#333,stroke-width:2px;
        style B fill:#4682B4,stroke:#333,stroke-width:2px;
        style C fill:#FFD700,stroke:#333,stroke-width:2px;
        style D fill:#FF6347,stroke:#333,stroke-width:2px;
        style E fill:#FF6347,stroke:#333,stroke-width:2px;`;

    // load the mermaid flowchart data to diagram
    //parameter: mermaidFlowchartData - mermaid format string data for flowchart
    this.diagram.loadDiagramFromMermaid(mermaidFlowchartData);
  }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Loading Mind Map Layout

The following example demonstrates loading a mind map diagram from Mermaid syntax:

import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { DiagramComponent, DiagramModule } from '@syncfusion/ej2-angular-diagrams';
import { Diagram, NodeModel, ConnectorModel, TextStyleModel, ShapeAnnotationModel,
  DecoratorModel, StrokeStyleModel, MindMap } from '@syncfusion/ej2-diagrams';

Diagram.Inject(MindMap);

@Component({
  imports: [
    DiagramModule
  ],

  providers: [],
  standalone: true,
  selector: "app-container",
  template: `
  <button (click)="loadMermaidMindmap()">Load</button>
  <ejs-diagram #diagram id="diagram" width="100%" height="600px" [getNodeDefaults]="getNodeDefaults"
  [getConnectorDefaults]="getConnectorDefaults" [layout]="layout"> </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  @ViewChild("diagram")
  public diagram!: DiagramComponent;

  public getNodeDefaults(node: NodeModel): NodeModel {
    node.width = 120;
    node.height = 50;
    return node;
  }

  public getConnectorDefaults(connector: ConnectorModel): ConnectorModel {
    connector.type = 'Orthogonal';
    (connector.targetDecorator as DecoratorModel).shape = 'None';
    return connector;
  }

  public layout = {
    type: 'MindMap',
    verticalSpacing: 50,
    horizontalSpacing: 50,
    orientation: 'Horizontal',
  }

  public loadMermaidMindmap() {
    const mermaidMindmapData = `mindmap
                            root((mindmap))
                              Origins
                                Popularisation
                              Research
                                On effectivness<br/>and features
                                On Automatic creation
                              Tools
                                Pen and paper
                                Mermaid `;

    // load the mermaid mindmap data to diagram
    //parameter: mermaidMindmapData - mermaid format string data for mindmap
    this.diagram.loadDiagramFromMermaid(mermaidMindmapData);
  }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Loading UML Sequence Diagram

The following example demonstrates loading a UML Sequence diagram from Mermaid syntax:

import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { DiagramComponent, DiagramModule } from '@syncfusion/ej2-angular-diagrams';

@Component({
  imports: [DiagramModule],
  providers: [],
  standalone: true,
  selector: "app-container",
  template: `
  <button (click)="loadMermaidSeqDiagram()">Load Mermaid</button>
  <ejs-diagram #diagram id="diagram" width="100%" height="600px"></ejs-diagram>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  @ViewChild("diagram")
  public diagram!: DiagramComponent;
  public loadMermaidSeqDiagram() {
    const mermaidData: string = `
 sequenceDiagram
    participant User
    participant Controller
    participant Service
    participant Database

    User->>Controller: sendRequest()
    activate Controller

    Controller->>Service: processRequest()
    activate Service

    Service->>Database: queryData()
    activate Database
    Database-->>Service: returnData()
    deactivate Database

    Service-->>Controller: returnResponse()
    deactivate Service

    Controller-->>User: sendResponse()
    deactivate Controller`;

    // load the mermaid sequence diagram data to diagram
    //parameter: mermaidData - mermaid format string data for UML Sequence Diagram
    this.diagram.loadDiagramFromMermaid(mermaidData);
  }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Mermaid syntax-based serialization and deserialization supports only Flowchart layout, Mind map layout, and UML Sequence Diagram. Ensure that your Mermaid data aligns with one of these supported layouts for successful diagram loading.

Serialization in React Diagram

21 Aug 202624 minutes to read

Serialization is the process of converting the diagram’s current state into a storage format that can be saved and later restored. This feature ensures that all diagram elements, including nodes, connectors, and their configurations, persist across application sessions.

The serialization process converts the diagram into a JSON string format, which can be stored in databases, files, or other storage systems. When needed, this serialized data can be deserialized to recreate the diagram exactly as it was previously configured.

Use serialization when you need to:

  • Save user-created diagrams for future editing.
  • Implement undo/redo functionality.
  • Create diagram templates.
  • Transfer diagrams between different sessions or users.

To save and load the diagram in React, refer to the below video link.

Saving Diagrams

Basic Save Operation

The saveDiagram method serializes the entire diagram configuration into a JSON string. This method captures all diagram elements, their properties, and the current state.

The following code illustrates how to save the diagram:


let saveData: string;
// Returns the serialized JSON string of the diagram.
saveData = diagramInstance.saveDiagram();

The saveDiagram() method returns an empty string when the diagram contains no elements.

The serialized JSON string can be stored in various storage systems. The following example demonstrates local storage implementation:

//Saves the string in to local storage
localStorage.setItem('fileName', saveData);

// Retrieve the saved string from local storage
saveData = localStorage.getItem('fileName');

Alternative Save Formats

The diagram can also be saved as raster or vector image files. For more information about saving the diagram as images, refer to the Print and Export sections.

Loading Diagrams

Basic Load Operation

The loadDiagram method recreates the diagram from serialized JSON data. This method accepts the previously saved JSON string as a parameter.


/*
 * Loads the diagram from saved JSON data.
 * parameter 1 - The string representing the diagram model JSON to be loaded.
 * parameter 2 - Whether it is ej1 data or not (optional)
 */
diagramInstance.loadDiagram(saveData);

Before loading a new diagram, the existing diagram content is automatically cleared.

To load diagrams created with Essential JS 1, pass true as the second parameter. See Migrating from ej1.

Handling Load Completion

The loaded event triggers when all diagram elements finish loading through the loadDiagram method. Use this event to perform post-load customizations or validations.

<DiagramComponent
  loaded={(args) => {
      // Customize diagram elements after loading is complete
  }}
/>

Refer to the loaded event arguments for customizing diagram elements after load.

The loaded event provides the following arguments:

name

Type: String

Description: Returns the event name.

diagram

Type: Diagram

Description: Returns the diagram model properties.

Users can perform customizations or modifications to the diagram elements once the loading process is complete.

Prevent Default Values

The preventDefaults property of serializationSettings reduces the size of serialized data by excluding default properties. This optimization improves performance when handling large diagrams or frequent save operations.

When enabled, only explicitly set properties are included in the JSON output, significantly reducing file size and improving load times.

return (
    <div>
      <DiagramComponent
        serializationSettings = 
      ></DiagramComponent>
    </div>
  )

Detect Unsaved Changes

The isModified property indicates whether the diagram has unsaved changes. It becomes true when the diagram is changed, such as when nodes, connectors, or diagram properties are updated, or when undo and redo actions are performed.

This property can be used to show save indicators or to display a warning before unsaved changes are discarded.

// Check whether the diagram has unsaved changes.
if (diagramInstance.isModified) {
    const confirmed = confirm('There are unsaved changes. Discard them?');

    if (!confirmed) {
        return;
    }
}

The confirm() call above is illustrative; replace it with your application’s confirmation dialog.

Transient interactions such as zooming, panning, or selecting elements do not affect the isModified state.

File-Based Save and Load Operations

Using Uploader Component

JSON files can be uploaded and processed using the uploader component. Configure the uploader with appropriate server endpoints to handle file operations, then parse the uploaded JSON data to load diagrams.

The uploader requires:

  • saveUrl property for receiving and storing uploaded files.
  • removeUrl property for handling file deletion operations.
  • Parse the uploaded file to extract the JSON diagram data for loading.

For more on configuring the uploader, see the Uploader component documentation.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from '@syncfusion/ej2-react-diagrams';
import { UploaderComponent } from '@syncfusion/ej2-react-inputs';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

export default function App() {
    let diagramInstance;

    // Initialize Uploader Object
    let uploadObject = {
        saveUrl:
            'https://services.syncfusion.com/js/production/api/FileUploader/Save',
        removeUrl:
            'https://services.syncfusion.com/js/production/api/FileUploader/Remove',
    }


    // Callback function for when the upload is successful
    function onUploadSuccess(args) {
        var file = args.file.rawFile;
        var reader = new FileReader();
        reader.readAsText(file);
        reader.onloadend = loadDiagram;
    }

    // Function to load the diagram from the uploaded file
    function loadDiagram(event) {
        diagramInstance.loadDiagram(event.target.result);
    }

    // Function to save the current diagram
    function saveDiagram() {
        download(diagramInstance.saveDiagram());
    }

    // Function to download the diagram data as a JSON file
    function download(data) {
        if (window.navigator.msSaveBlob) {
            let blob = new Blob([data], { type: 'data:text/json;charset=utf-8,' });
            window.navigator.msSaveBlob(blob, 'Diagram.json');
        } else {
            let dataStr = 'data:text/json;charset=utf-8,' + encodeURIComponent(data);
            let a = document.createElement('a');
            a.href = dataStr;
            a.download = 'Diagram.json';
            document.body.appendChild(a);
            a.click();
            a.remove();
        }
    }

    // Initialize nodes for the diagram
    let nodes = [
        {
            id: 'Start',
            width: 140,
            height: 50,
            offsetX: 300,
            offsetY: 50,
            annotations: [{ id: 'label1', content: 'Start' }],
            shape: { type: 'Flow', shape: 'Terminator' }
        },
    ];

    return (
        // Initialize Diagram component
        <div>
            <label>Browse to load</label>
            <UploaderComponent asyncSettings={uploadObject} success={onUploadSuccess} />
            <ButtonComponent content="Save Diagram" onClick={saveDiagram} />
            <DiagramComponent
                id="container"
                ref={(diagram) => (diagramInstance = diagram)}
                width={'100%'}
                height={'600px'}
                nodes={nodes}
            ></DiagramComponent>
        </div>
    );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, NodeModel } from '@syncfusion/ej2-react-diagrams';
import { UploaderComponent, FileInfo } from '@syncfusion/ej2-react-inputs';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

export default function App() {
  let diagramInstance: DiagramComponent;

  // Initialize Uploader Object
  let uploadObject = {
    saveUrl:
      'https://services.syncfusion.com/js/production/api/FileUploader/Save',
    removeUrl:
      'https://services.syncfusion.com/js/production/api/FileUploader/Remove',
  }

  // Callback function for when the upload is successful
  function onUploadSuccess(args: { file: FileInfo }) {
    var file: any = args.file.rawFile;
    var reader = new FileReader();
    reader.readAsText(file);
    reader.onloadend = loadDiagram;
  }

  // Function to load the diagram from the uploaded file
  function loadDiagram(event: any) {
    diagramInstance.loadDiagram(event.target.result);
  }

  // Function to save the current diagram
  function saveDiagram() {
    download(diagramInstance.saveDiagram());
  }

  // Function to download the diagram data as a JSON file
  function download(data: string) {
    if ((window.navigator as any).msSaveBlob) {
      let blob = new Blob([data], { type: 'data:text/json;charset=utf-8,' });
      (window.navigator as any).msSaveBlob(blob, 'Diagram.json');
    } else {
      let dataStr = 'data:text/json;charset=utf-8,' + encodeURIComponent(data);
      let a: HTMLAnchorElement = document.createElement('a');
      a.href = dataStr;
      a.download = 'Diagram.json';
      document.body.appendChild(a);
      a.click();
      a.remove();
    }
  }

  // Initialize nodes for the diagram
  let nodes: NodeModel[] = [
    {
      id: 'Start',
      width: 140,
      height: 50,
      offsetX: 300,
      offsetY: 50,
      annotations: [{ id: 'label1', content: 'Start' }],
      shape: { type: 'Flow', shape: 'Terminator' }
    },
  ];

  return (
    // Initialize Diagram component
    <div>
      <UploaderComponent asyncSettings={uploadObject} success={onUploadSuccess} />
      <ButtonComponent content="Save Diagram" onClick={saveDiagram} />
      <DiagramComponent
        id="container"
        ref={(diagram: any) => (diagramInstance = diagram)}
        width={'100%'}
        height={'600px'}
        nodes={nodes}
      />
    </div>
  );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram") as HTMLElement);
root.render(<App />);

Mermaid Syntax Integration

Overview

The Diagram component supports importing and exporting diagrams using Mermaid syntax. Mermaid is a markdown-inspired syntax for creating diagrams programmatically, enabling easy diagram creation and sharing across different platforms.

This functionality supports:

  • Mind maps
  • Flowcharts
  • UML sequence diagrams

For supported Mermaid syntax, refer to the Mermaid documentation. Only a subset of syntax is supported for Flowchart, Mind map, and UML Sequence layouts.

Saving Diagrams as Mermaid Syntax

The saveDiagramAsMermaid method converts compatible diagrams into Mermaid syntax format. This method works specifically with Flowchart and Mind map layouts.

// Returns the serialized Mermaid string of the diagram.
let data = diagramInstance.saveDiagramAsMermaid();

Load Diagram from Mermaid Syntax

The loadDiagramFromMermaid method creates diagrams from Mermaid syntax data, automatically generating the appropriate layout and styling.

Load Flowchart Layout

The following example shows how to load flowchart diagram from mermaid syntax.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, FlowchartLayout } from "@syncfusion/ej2-react-diagrams";

export default function App() {
    let diagramInstance;

    // Mermaid syntax for the flowchart data
    let mermaidFlowchartData = `flowchart TD
        A[Start] --> B(Process)
        B -.- C{Decision}
        C --Yes--> D[Plan 1]
        C ==>|No| E[Plan 2]
        style A fill:#90EE90,stroke:#333,stroke-width:2px;
        style B fill:#4682B4,stroke:#333,stroke-width:2px;
        style C fill:#FFD700,stroke:#333,stroke-width:2px;
        style D fill:#FF6347,stroke:#333,stroke-width:2px;
        style E fill:#FF6347,stroke:#333,stroke-width:2px;`;

    // Function to set default properties for nodes
    function getNodeDefaults(node) {
        node.width = 120;
        node.height = 50;
        if (node.shape.shape === 'Decision') {
            node.height = 80;
        }
        node.annotations[0].style.bold = true;
        return node;
    };

    // Function to set default properties for connectors
    function getConnectorDefaults(connector) {
        connector.type = 'Orthogonal';
        return connector;
    };

    // Function to load the Mermaid flowchart data into the diagram
    function loadMermaidFlowchart() {
        diagramInstance.loadDiagramFromMermaid(mermaidFlowchartData);
    };

    return (
      // Initialize Diagram component
        <div>
            <button onClick={loadMermaidFlowchart} id="loadMermaidFlowchart">Load Mermaid Flowchart</button>
            <DiagramComponent
                id="container"
                ref={(diagram) => (diagramInstance = diagram)}
                width={"100%"}
                height={"600px"}
                layout=
                getNodeDefaults={getNodeDefaults}
                getConnectorDefaults={getConnectorDefaults}
            >
                <Inject services={[FlowchartLayout]} />
            </DiagramComponent>
        </div>
    );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, FlowchartLayout, ConnectorModel, NodeModel } from "@syncfusion/ej2-react-diagrams";

export default function App() {
  let diagramInstance: DiagramComponent;

  // Mermaid syntax for the flowchart data
  let mermaidFlowchartData: string = `flowchart TD
        A[Start] --> B(Process)
        B -.- C{Decision}
        C --Yes--> D[Plan 1]
        C ==>|No| E[Plan 2]
        style A fill:#90EE90,stroke:#333,stroke-width:2px;
        style B fill:#4682B4,stroke:#333,stroke-width:2px;
        style C fill:#FFD700,stroke:#333,stroke-width:2px;
        style D fill:#FF6347,stroke:#333,stroke-width:2px;
        style E fill:#FF6347,stroke:#333,stroke-width:2px;`;

  // Function to set default properties for nodes
  function getNodeDefaults(node: NodeModel | any): NodeModel {
    node.width = 120;
    node.height = 50;
    if (node.shape.shape === 'Decision') {
      node.height = 80;
    }
    node.annotations[0].style.bold = true;
    return node;
  };

  // Function to set default properties for connectors
  function getConnectorDefaults(connector: ConnectorModel): ConnectorModel {
    connector.type = 'Orthogonal';
    return connector;
  };

  // Function to load the Mermaid flowchart data into the diagram
  function loadMermaidFlowchart(): void {
    diagramInstance.loadDiagramFromMermaid(mermaidFlowchartData);
  };

  return (
    // Initialize Diagram component
    <div>
      <button onClick={loadMermaidFlowchart} id="loadMermaidFlowchart">Load Mermaid Flowchart</button>
      <DiagramComponent
        id="container"
        ref={(diagram: any) => (diagramInstance = diagram)}
        width={"100%"}
        height={"600px"}
        layout=
        getNodeDefaults={getNodeDefaults}
        getConnectorDefaults={getConnectorDefaults}
      >
        <Inject services={[FlowchartLayout]} />
      </DiagramComponent>
    </div>
  );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram") as HTMLElement);
root.render(<App />);

Loading Mind Map Layout

The following example demonstrates loading a mind map diagram from Mermaid syntax:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, MindMap } from "@syncfusion/ej2-react-diagrams";

export default function App() {
    let diagramInstance;

    // Mermaid syntax for the mindmap data
    let mermaidMindmapData = `mindmap
                              root((mindmap))
                                Origins
                                  Popularisation
                                Research
                                  On effectiveness<br/>and features
                                  On Automatic creation
                                Tools
                                  Pen and paper
                                  Mermaid`;

    // Function to set default properties for nodes
    function getNodeDefaults(node) {
        node.width = 140;
        node.height = 50;
        node.annotations[0].style.bold = true;
        return node;
    };

    // Function to set default properties for connectors
    function getConnectorDefaults(connector) {
        connector.type = 'Orthogonal';
        return connector;
    };

    // Function to load the Mermaid mindmap data into the diagram
    function loadMermaidMindmap() {
        diagramInstance.loadDiagramFromMermaid(mermaidMindmapData);
    };

    return (
        // Initialize Diagram component
        <div>
            <button onClick={loadMermaidMindmap} id="loadMermaidMindmap">Load Mermaid Mindmap</button>
            <DiagramComponent
                id="container"
                ref={(diagram) => (diagramInstance = diagram)}
                width={"100%"}
                height={"350px"}
                layout=
                getNodeDefaults={getNodeDefaults}
                getConnectorDefaults={getConnectorDefaults}
            >
                <Inject services={[MindMap]} />
            </DiagramComponent>
        </div>
    );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, MindMap, NodeModel, ConnectorModel } from "@syncfusion/ej2-react-diagrams";

export default function App() {
  let diagramInstance: DiagramComponent;

  // Mermaid syntax for the mindmap data
  let mermaidMindmapData: string = `mindmap
                              root((mindmap))
                                Origins
                                  Popularisation
                                Research
                                  On effectiveness<br/>and features
                                  On Automatic creation
                                Tools
                                  Pen and paper
                                  Mermaid`;

  // Function to set default properties for nodes
  function getNodeDefaults(node: NodeModel | any): NodeModel {
    node.width = 140;
    node.height = 50;
    node.annotations[0].style.bold = true;
    return node;
  };

  // Function to set default properties for connectors
  function getConnectorDefaults(connector: ConnectorModel): ConnectorModel {
    connector.type = 'Orthogonal';
    return connector;
  };

  // Function to load the Mermaid mindmap data into the diagram
  function loadMermaidMindmap() {
    diagramInstance.loadDiagramFromMermaid(mermaidMindmapData);
  };

  return (
    // Initialize Diagram component
    <div>
      <button onClick={loadMermaidMindmap} id="loadMermaidMindmap">Load Mermaid Mindmap</button>
      <DiagramComponent
        id="container"
        ref={(diagram: any) => (diagramInstance = diagram)}
        width={"100%"}
        height={"350px"}
        layout=
        getNodeDefaults={getNodeDefaults}
        getConnectorDefaults={getConnectorDefaults}
      >
        <Inject services={[MindMap]} />
      </DiagramComponent>
    </div>
  );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram") as HTMLElement);
root.render(<App />);

Loading UML Sequence Diagram

The following example demonstrates loading a UML Sequence diagram from Mermaid syntax:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";

export default function App() {
let diagramInstance;
const mermaidData = `
 sequenceDiagram
    participant User
    participant Controller
    participant Service
    participant Database

    User->>Controller: sendRequest()
    activate Controller

    Controller->>Service: processRequest()
    activate Service

    Service->>Database: queryData()
    activate Database
    Database-->>Service: returnData()
    deactivate Database

    Service-->>Controller: returnResponse()
    deactivate Service

    Controller-->>User: sendResponse()
    deactivate Controller`;

    // Function to load the Mermaid sequence diagram data into the diagram
    function loadMermaidSeqDiagram() {
        diagramInstance.loadDiagramFromMermaid(mermaidData);
    };

    return (
        // Initialize Diagram component
        <div>
            <button onClick={loadMermaidSeqDiagram} id="loadMermaid">Load Mermaid</button>
            <DiagramComponent
                id="container" ref={(diagram) => (diagramInstance = diagram)}
                width={"100%"} height={"600px"}>
            </DiagramComponent>
        </div>
    );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";

export default function App() {
  let diagramInstance: DiagramComponent;
  const mermaidData: string = `
 sequenceDiagram
    participant User
    participant Controller
    participant Service
    participant Database

    User->>Controller: sendRequest()
    activate Controller

    Controller->>Service: processRequest()
    activate Service

    Service->>Database: queryData()
    activate Database
    Database-->>Service: returnData()
    deactivate Database

    Service-->>Controller: returnResponse()
    deactivate Service

    Controller-->>User: sendResponse()
    deactivate Controller`;

  // Function to load the Mermaid sequence diagram data into the diagram
  function loadMermaidSeqDiagram() {
    diagramInstance.loadDiagramFromMermaid(mermaidData);
  };

  return (
    // Initialize Diagram component
    <div>
      <button onClick={loadMermaidSeqDiagram} id="loadMermaid">Load Mermaid</button>
      <DiagramComponent
        id="container" ref={(diagram: any) => (diagramInstance = diagram)}
        width={"100%"} height={"600px"}>
      </DiagramComponent>
    </div>
  );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram") as HTMLElement);
root.render(<App />);

Mermaid syntax-based serialization and deserialization supports only Flowchart layout, Mind map layout, and UML Sequence Diagram. Ensure that your Mermaid data aligns with one of these supported layouts for successful diagram loading.

Serialization in Vue Diagram

06 Aug 202624 minutes to read

Serialization is the process of converting the state of the Vue Diagram into a format that can be saved and later restored. This ensures that the diagram’s current state, including its nodes, connectors, and configurations, can be persisted across sessions.

Serialization involves saving the diagram’s state as a JSON string, which can then be stored in a database, file, or other storage medium. When needed, the serialized string can be deserialized to recreate the diagram in its previous state.

Save

The diagram is serialized as string while saving. The client-side method, saveDiagram, helps to serialize the diagram as a string. This method captures the entire diagram’s configuration and content, converting it into a string

The following code illustrates how to save the diagram:

//returns serialized string of the Diagram
const saveData = diagramInstance.saveDiagram();

This JSON string can be stored in local storage for future use. The following code illustrates how to save the serialized string into local storage and how to retrieve it:

//Saves the string in to local storage
localStorage.setItem('fileName', saveData);

// Retrieve the saved string from local storage
saveData = localStorage.getItem('fileName');

The diagram can also be saved as raster or vector image files. For more information about saving the diagram as images, refer to the Print and Export section.

Load

Diagram is loaded from the serialized string data by client-side method, loadDiagram method. The saved string should be passed as the parameter of the loadDiagram method. The following code illustrates how to load the diagram from serialized string data:

/*
 * Loads the diagram from saved JSON data.
 * parameter 1 - The string representing the diagram model JSON to be loaded.
 * parameter 2 - Whether it is ej1 data or not (optional)
 */
diagramInstance.loadDiagram(saveData);

Before loading a new diagram, existing diagram is cleared.

Loaded Event

The loaded event triggers when all diagram elements are loaded using loadDiagram method. You can use this event to customize diagram elements during the loading process.

<ejs-diagram id="diagram" :width='width' :height='height' :loaded='loaded'>
</ejs-diagram>

export default {
  name: 'App',
  components: {
    'ejs-diagram': DiagramComponent,
  },
  data () {
    return {
      width: "100%",
      height: "700px",
      loaded:(args) => {
        //You can use this event to customize diagram elements during the loading process
      },
    }
  }
}

The event has two arguments such as name, diagram

name

Type: String

Description: Returns the event name.

diagram

Type: Diagram

Description: Returns the diagram model properties.

Users can perform customizations or modifications to the diagram elements once the loading process is complete.

Prevent default values

The preventDefaults property of serializationSettings is used to simplify the saved JSON object by excluding default properties that are inherent to the diagram. This helps reduce the size of the serialized data and improves efficiency when saving and loading diagrams.

By enabling preventDefaults, only properties that you set in diagram are included in the serialized JSON object. This optimization is useful for scenarios where minimizing data size is crucial, such as in applications with large diagrams or when optimizing network transfers.

The following code illustrates how to enable the preventDefaults property to simplify the JSON object:

let diagram: Diagram = new Diagram({
 serializationSettings: { preventDefaults: true },
});

Detect unsaved changes

The isModified property indicates whether the diagram has unsaved changes. It becomes true when the diagram is changed, such as when nodes, connectors, or diagram properties are updated, or when undo and redo actions are performed.

For example, this property can be used to show a save indicator or display a warning message before closing or navigating away from a diagram with unsaved changes.

// Check whether the diagram has unsaved changes.
if (diagram.isModified) {
    const confirmed = confirm('There are unsaved changes. Discard them?');

    if (!confirmed) {
        return;
    }
}

Transient interactions such as zooming, panning, or selecting elements do not affect the isModified state.

Save and load diagram using Uploader control

The JSON files can be uploaded using the Uploader component, where they are parsed to extract the JSON data they contain. To achieve this, configure the Uploader component with the saveUrl property to receive uploaded files and store them on the server. Similarly, use the removeUrl property to handle file removal operations on the server.

When a JSON file is uploaded, it undergoes parsing to extract its JSON data. This data is then loaded into the diagram using the loadDiagram method.

<template>
    <div id="app">
  
      <ejs-uploader ref="uploadObj" id="defaultfileupload" name="UploadFiles" :asyncSettings="path"
        :success="onUploadSuccess"></ejs-uploader>
      <button v-on:click="saveDiagram">Save Diagram</button>
  
      <ejs-diagram id="diagram" ref="diagramObj" :width="width" :height="height" :nodes="nodes"></ejs-diagram>
  
    </div>
  </template>
  
  <script setup>
  import { ref, onMounted } from "vue";
  import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';
  import { UploaderComponent as EjsUploader } from '@syncfusion/ej2-vue-inputs';
  
  let diagramInstance;
  let diagramObj = ref(null);
  
  // Data properties
  const nodes = [
    {
      id: 'Start',
      width: 140,
      height: 50,
      offsetX: 300,
      offsetY: 150,
      annotations: [{ id: 'label1', content: 'Start' }],
      shape: { type: 'Flow', shape: 'Terminator' }
    },
  ];
  
  const width = "1000px";
  const height = "590px";
  
  const path = {
    saveUrl:
      'https://services.syncfusion.com/vue/production/api/FileUploader/Save',
    removeUrl:
      'https://services.syncfusion.com/vue/production/api/FileUploader/Remove',
  };
  
  
  onMounted(function () {
    diagramInstance = diagramObj.value.ej2Instances;
  })
  
  // Handle file upload success
  const onUploadSuccess = (args) => {
    const file = args.file.rawFile;
    const reader = new FileReader();
    reader.readAsText(file);
    reader.onloadend = loadDiagram;
  }
  
  // Load diagram data from file
  const loadDiagram = (event) => {
    const jsonString = event.target.result;
    diagramInstance.loadDiagram(jsonString);
  }
  
  // Download diagram as a JSON file
  const download = (data) => {
    if (window.navigator.msSaveBlob) {
      const blob = new Blob([data], { type: 'data:text/json;charset=utf-8,' });
      window.navigator.msSaveBlob(blob, 'Diagram.json');
    } else {
      const dataStr = 'data:text/json;charset=utf-8,' + encodeURIComponent(data);
      const a = document.createElement('a');
      a.href = dataStr;
      a.download = 'Diagram.json';
      document.body.appendChild(a);
      a.click();
      a.remove();
    }
  }
  
  // Save the diagram
  const saveDiagram = () => {
    const diagramData = diagramInstance.saveDiagram();
    download(diagramData);
  }
  
  </script>
  
  <style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        
        <ejs-uploader ref="uploadObj" id="defaultfileupload" name="UploadFiles" :asyncSettings="path"
            :success="onUploadSuccess" ></ejs-uploader>
        <button v-on:click="saveDiagram">Save Diagram</button>

        <ejs-diagram id="diagram" ref="diagramObj" :width="width" :height="height" :nodes="nodes"></ejs-diagram>
    </div>
</template>

<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';
import { UploaderComponent } from '@syncfusion/ej2-vue-inputs';

var diagramInstance;
var nodes = [
    {
        id: 'Start',
        width: 140,
        height: 50,
        offsetX: 300,
        offsetY: 150,
        annotations: [{ id: 'label1', content: 'Start' }],
        shape: { type: 'Flow', shape: 'Terminator' },
    },
];

export default {
    name: 'App',
    components: {
        'ejs-diagram': DiagramComponent,
        'ejs-uploader': UploaderComponent,
    },
    data() {
        return {
            width: '100%',
            height: '650px',
            nodes: nodes,
            path: {
                saveUrl:
                    'https://services.syncfusion.com/vue/production/api/FileUploader/Save',
                removeUrl:
                    'https://services.syncfusion.com/vue/production/api/FileUploader/Remove',
            }
        };
    },
    methods: {
        // Handle file upload success
        onUploadSuccess(args) {
            const file = args.file.rawFile;
            const reader = new FileReader();
            reader.readAsText(file);
            reader.onloadend = this.loadDiagram;
        },

        // Load diagram data from file
        loadDiagram(event) {
            const jsonString = event.target.result;
            diagramInstance.loadDiagram(jsonString);
        },

        // Download diagram as a JSON file
        download(data) {
            if (window.navigator.msSaveBlob) {
                const blob = new Blob([data], {
                    type: 'data:text/json;charset=utf-8,',
                });
                window.navigator.msSaveBlob(blob, 'Diagram.json');
            } else {
                const dataStr =
                    'data:text/json;charset=utf-8,' + encodeURIComponent(data);
                const a = document.createElement('a');
                a.href = dataStr;
                a.download = 'Diagram.json';
                document.body.appendChild(a);
                a.click();
                a.remove();
            }
        },

        // Save the diagram
        saveDiagram() {
            const diagramData = diagramInstance.saveDiagram();
            this.download(diagramData);
        },
    },
    mounted: function () {
        diagramInstance = this.$refs.diagramObj.ej2Instances;
    }
};

</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Importing and Exporting Diagrams using Mermaid Syntax

The Diagram supports saving diagrams in Mermaid syntax format. Mermaid is a Markdown-inspired syntax that automatically generates diagrams. With this functionality, you can easily create mind maps, flowcharts, and UML sequence diagrams from Mermaid syntax data, simplifying the visualization of complex ideas and processes without manual drawing. Additionally, you can export your mind maps, flowcharts, and UML sequence diagrams to Mermaid syntax, allowing for easy sharing, editing, and use across different platforms.

Save diagram as Mermaid syntax

The saveDiagramAsMermaid method serializes the diagram into a Mermaid-compatible string format. This method is specifically designed for diagrams that utilize Flowchart and Mind map layouts. The following code illustrates how to save the diagram in Mermaid string format.

//returns the serialized Mermaid string of the Diagram
let data = diagramInstance.saveDiagramAsMermaid();

Load diagram from Mermaid syntax

You can load a diagram from the serialized Mermaid syntax data using the loadDiagramFromMermaid method. The following code illustrates how to load a diagram from a Mermaid string data.

Load Flowchart layout

The following example shows how to load flowchart diagram from mermaid syntax.

<template>
    <div id="app">

        <button v-on:click="loadMermaidFlowchart">Load</button>

        <ejs-diagram id="diagram" ref="diagramObj" :width="width" :height="height" :layout="layout"
            :getNodeDefaults="getNodeDefaults" :getConnectorDefaults="getConnectorDefaults"></ejs-diagram>

    </div>
</template>

<script setup>
import { provide, ref, onMounted } from "vue";
import { DiagramComponent as EjsDiagram, FlowchartLayout } from '@syncfusion/ej2-vue-diagrams';

let diagramInstance;
let diagramObj = ref(null);

const width = "1000px";
const height = "590px";

//Sets layout type
const layout = { type: 'Flowchart' }

//Sets the default properties for nodes and connectors
const getNodeDefaults = (node) => {
    node.width = 120;
    node.height = 50;
    if ((node.shape).shape === 'Decision') {
        node.height = 80;
    }
    (node.annotations[0].style).bold = true;
    return node;
}

const getConnectorDefaults = (connector) => {
    connector.type = 'Orthogonal';
    connector.style.strokeColor = '#6CA0DC';
    connector.targetDecorator.style = { fill: '#6CA0DC', strokeColor: '#6CA0DC' };
    return connector;
}

onMounted(function () {
    diagramInstance = diagramObj.value.ej2Instances;
})

const loadMermaidFlowchart = () => {
    const mermaidFlowchartData = `flowchart TD
                  A[Start] --> B(Process)
                  B -.- C{Decision}
                  C --Yes--> D[Plan 1]
                  C ==>|No| E[Plan 2]
                  style A fill:#90EE90,stroke:#333,stroke-width:2px;
                  style B fill:#4682B4,stroke:#333,stroke-width:2px;
                  style C fill:#FFD700,stroke:#333,stroke-width:2px;
                  style D fill:#FF6347,stroke:#333,stroke-width:2px;
                  style E fill:#FF6347,stroke:#333,stroke-width:2px;`;

    // load the mermaid mindmap data to diagram
    //parameter: mermaidMindmapData - mermaid format string data for mindmap
    diagramInstance.loadDiagramFromMermaid(mermaidFlowchartData);
}

provide('diagram', [FlowchartLayout]);
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">

        <button v-on:click="loadMermaidFlowchart">Load</button>

        <ejs-diagram id="diagram" ref="diagramObj" :width="width" :height="height" :layout="layout"
            :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults'></ejs-diagram>
    
    </div>
</template>

<script>
import { DiagramComponent, FlowchartLayout, } from '@syncfusion/ej2-vue-diagrams';

var diagramInstance;
var nodes = [];

export default {
    name: 'App',
    components: {
        'ejs-diagram': DiagramComponent,
    },
    data() {
        return {
            width: '100%',
            height: '650px',

            //Sets layout type
            layout: { type: 'Flowchart' },

            //Sets the default properties for nodes and connectors
            getNodeDefaults(node) {
                node.width = 120;
                node.height = 50;
                if ((node.shape).shape === 'Decision') {
                    node.height = 80;
                }
                (node.annotations[0].style).bold = true;
                return node;
            },

            getConnectorDefaults(connector) {
                connector.type = 'Orthogonal';
                connector.style.strokeColor = '#6CA0DC';
                connector.targetDecorator.style = { fill: '#6CA0DC', strokeColor: '#6CA0DC' };
                return connector;
            },
        };
    },
    methods: {
        loadMermaidFlowchart() {
            const mermaidFlowchartData = `flowchart TD
                A[Start] --> B(Process)
                B -.- C{Decision}
                C --Yes--> D[Plan 1]
                C ==>|No| E[Plan 2]
                style A fill:#90EE90,stroke:#333,stroke-width:2px;
                style B fill:#4682B4,stroke:#333,stroke-width:2px;
                style C fill:#FFD700,stroke:#333,stroke-width:2px;
                style D fill:#FF6347,stroke:#333,stroke-width:2px;
                style E fill:#FF6347,stroke:#333,stroke-width:2px;`;

            // load the mermaid flowchart data to diagram
            //parameter: mermaidFlowchartData - mermaid format string data for flowchart
            diagramInstance.loadDiagramFromMermaid(mermaidFlowchartData);
        }
    },
    mounted: function () {
        diagramInstance = this.$refs.diagramObj.ej2Instances;
    },
    provide: { diagram: [FlowchartLayout] }
};

</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Load Mind Map layout

The following example shows how to load mind map diagram from mermaid syntax.

<template>
    <div id="app">

        <button v-on:click="loadMermaidMindmap">Load</button>

        <ejs-diagram id="diagram" ref="diagramObj" :width="width" :height="height" :layout="layout"
            :getNodeDefaults="getNodeDefaults" :getConnectorDefaults="getConnectorDefaults"></ejs-diagram>

    </div>
</template>

<script setup>
import { provide, ref, onMounted } from "vue";
import { DiagramComponent as EjsDiagram, MindMap } from '@syncfusion/ej2-vue-diagrams';

let diagramInstance;
let diagramObj = ref(null);

const width = "1000px";
const height = "590px";

//Sets layout type
const layout = {
    type: 'MindMap',
    verticalSpacing: 50,
    horizontalSpacing: 50,
    orientation: 'Horizontal',
}

//Sets the default properties for nodes and connectors
const getNodeDefaults = (node) => {
    node.width = 120;
    node.height = 50;
    node.annotations[0].style.bold = true;
    return node;
}

const getConnectorDefaults = (connector) => {
    connector.type = 'Orthogonal';
    connector.style.strokeColor = '#6CA0DC';
    connector.targetDecorator.shape = 'None';
    return connector;
}

onMounted(function () {
    diagramInstance = diagramObj.value.ej2Instances;
})

const loadMermaidMindmap = () => {
    const mermaidMindmapData = `mindmap
                                      root((mindmap))
                                        Origins
                                          Popularisation
                                        Research
                                          On effectivness and features
                                          On Automatic creation
                                        Tools
                                          Pen and paper
                                          Mermaid `;

    // load the mermaid mindmap data to diagram
    //parameter: mermaidMindmapData - mermaid format string data for mindmap
    diagramInstance.loadDiagramFromMermaid(mermaidMindmapData);
}

provide('diagram', [MindMap]);
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">

        <button v-on:click="loadMermaidMindmap">Load</button>

        <ejs-diagram id="diagram" ref="diagramObj" :width="width" :height="height" :layout="layout"
            :getNodeDefaults="getNodeDefaults" :getConnectorDefaults="getConnectorDefaults"></ejs-diagram>

    </div>
</template>

<script>
import { DiagramComponent, MindMap } from '@syncfusion/ej2-vue-diagrams';

var diagramInstance;
var nodes = [];

export default {
    name: 'App',
    components: {
        'ejs-diagram': DiagramComponent,
    },
    data() {
        return {
            width: '100%',
            height: '650px',
            //Sets layout type
            layout: {
                type: 'MindMap',
                verticalSpacing: 50,
                horizontalSpacing: 50,
                orientation: 'Horizontal',
            },

            //Sets the default properties for nodes and connectors
            getNodeDefaults(node) {
                node.width = 120;
                node.height = 50;
                node.annotations[0].style.bold = true;
                return node;
            },

            getConnectorDefaults(connector) {
                connector.type = 'Orthogonal';
                connector.style.strokeColor = '#6CA0DC';
                connector.targetDecorator.shape = 'None';
                return connector;
            },

        };
    },
    methods: {
        loadMermaidMindmap() {
            const mermaidMindmapData = `mindmap
                                    root((mindmap))
                                      Origins
                                        Popularisation
                                      Research
                                        On effectivness and features
                                        On Automatic creation
                                      Tools
                                        Pen and paper
                                        Mermaid `;

            // load the mermaid mindmap data to diagram
            //parameter: mermaidMindmapData - mermaid format string data for mindmap
            diagramInstance.loadDiagramFromMermaid(mermaidMindmapData);
        },
    },
    mounted: function () {
        diagramInstance = this.$refs.diagramObj.ej2Instances;
    },
    provide: { diagram: [MindMap] },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Load UML Sequence diagram

The following example shows how to load UML Sequence diagram from mermaid syntax:

<template>
    <div id="app">
        <button v-on:click="loadMermaidSeqDiagram">Load Mermaid</button>
        <ejs-diagram id="diagram" ref="diagramObj" :width="width" :height="height"></ejs-diagram>
    </div>
</template>

<script setup>
import { ref, onMounted } from "vue";
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';

let diagramInstance;
let diagramObj = ref(null);

const width = "1000px";
const height = "600px";
onMounted(function () {
    diagramInstance = diagramObj.value.ej2Instances;
})

const loadMermaidSeqDiagram = () => {
    const mermaidData = `
 sequenceDiagram
    participant User
    participant Controller
    participant Service
    participant Database

    User->>Controller: sendRequest()
    activate Controller

    Controller->>Service: processRequest()
    activate Service

    Service->>Database: queryData()
    activate Database
    Database-->>Service: returnData()
    deactivate Database

    Service-->>Controller: returnResponse()
    deactivate Service

    Controller-->>User: sendResponse()
    deactivate Controller`;

    // load the mermaid sequence diagram data to diagram
    //parameter: mermaidData - mermaid format string data for UML Sequence Diagram
    diagramInstance.loadDiagramFromMermaid(mermaidData);
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <button v-on:click="loadMermaidSeqDiagram">Load Mermaid</button>
        <ejs-diagram id="diagram" ref="diagramObj" :width="width" :height="height"></ejs-diagram>
    </div>
</template>

<script>
import { DiagramComponent } from '@syncfusion/ej2-vue-diagrams';

var diagramInstance;

export default {
    name: 'App',
    components: {
        'ejs-diagram': DiagramComponent,
    },
    data() {
        return {
            width: '100%',
            height: '600px',
        };
    },
    methods: {
        loadMermaidSeqDiagram() {
            const mermaidData = `
 sequenceDiagram
    participant User
    participant Controller
    participant Service
    participant Database

    User->>Controller: sendRequest()
    activate Controller

    Controller->>Service: processRequest()
    activate Service

    Service->>Database: queryData()
    activate Database
    Database-->>Service: returnData()
    deactivate Database

    Service-->>Controller: returnResponse()
    deactivate Service

    Controller-->>User: sendResponse()
    deactivate Controller`;

            // load the mermaid sequence diagram data to diagram
            //parameter: mermaidData - mermaid format string data for UML Sequence Diagram
            diagramInstance.loadDiagramFromMermaid(mermaidData);
        },
    },
    mounted: function () {
        diagramInstance = this.$refs.diagramObj.ej2Instances;
    },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Mermaid syntax-based serialization and deserialization is supported only for Flowchart layout, Mind map layout, and UML Sequence Diagram. Ensure that your Mermaid data aligns with one of these supported layouts to enable successful diagram loading.